import QtQuick 1.1

Item {
    id: mainv
    width: isPortrait ? 480 : 800
    height: isPortrait ? 800 : 480
    property int i
    property int gridLeftMargin: isPortrait ? 40 : 50
    property int gridRightMargin: isPortrait ? 40 : 50
    signal sectionMenuVisibleChanged(bool visible)
    property alias appflickable: appflickable



//    Rectangle {
//        anchors.right: parent.right
//        anchors.topMargin: 40
//        anchors.top: parent.top
//        anchors.bottom: parent.bottom
//        anchors.bottomMargin: 40
//        width: 1
//        color: "#35a6a4"
//        opacity: 0.6
//    }

    Connections {
        target: mainView
        onAppFound: {
            if (item.section.indexOf("office") == 0) {
                officeGrid.repeater.model.insert(0, item)
                officeGrid.visible = true
            } else if (item.section.indexOf("recent") == 0) {

                recentGrid.repeater.model.insert(0, item)

                if (recentGrid.repeater.model.count > 14) {
                    recentGrid.repeater.model.remove(
                                recentGrid.repeater.model.count - 1)
                }

                recentGrid.visible = true
            } else if (item.section.indexOf("desktop") == 0 ) {
                desktopGrid.repeater.model.insert(0, item)
                desktopGrid.visible = true
            } else if (item.section.indexOf("graphics") == 0) {
                graphicsGrid.repeater.model.insert(0, item)
                graphicsGrid.visible = true
            } else if (item.section.indexOf("education") == 0
                       || item.section.indexOf("science") == 0) {
                educationGrid.repeater.model.insert(0, item)
                educationGrid.visible = true
            } else if (item.section.indexOf("game") == 0) {
                gamesGrid.repeater.model.insert(0, item)
                gamesGrid.visible = true
            } else if (item.section.indexOf("network") == 0) {
                networkGrid.repeater.model.insert(0, item)
                networkGrid.visible = true
            } else if (item.section.indexOf("system") == 0) {
                systemGrid.repeater.model.insert(0, item)
                systemGrid.visible = true
            } else if (item.section.indexOf("utility") == 0
                       || item.section.indexOf("utilities") == 0) {
                utilitiesGrid.repeater.model.insert(0, item)
                utilitiesGrid.visible = true
            } else if (item.section.indexOf("navigation") == 0) {
                locationGrid.repeater.model.insert(0, item)
                locationGrid.visible = true
            } else if (item.section.indexOf("development") == 0) {
                developmentGrid.repeater.model.insert(0, item)
                developmentGrid.visible = true
            } else if (item.section.indexOf("audiovideo") == 0
                       || item.section.indexOf("multimedia") == 0) {
                multimediaGrid.repeater.model.insert(0, item)
                multimediaGrid.visible = true
            } else if (item.section.indexOf("other") == 0) {
                //  console.log("found other")
                otherGrid.repeater.model.insert(0, item)
                otherGrid.visible = true
            } else if (item.section.indexOf("") == 0) {
                console.log("found empty")
                otherGrid.repeater.model.insert(0, item)
                otherGrid.visible = true
            } else {
                console.log("found else:")
                console.log("section: " + item.section)
                otherGrid.repeater.model.insert(0, item)
                otherGrid.visible = true
            }

            //  gridView.repeater.model.insert(0, item)
            appflickable.contentY = 0
        }

        onSetSearchText: {
            if (stext == "") {
                recentGrid.visible = true
                searchGrid.visible = false
                column.visible = true
               // appflickable.contentHeight = column.height + 70
            } else {
                recentGrid.visible = false
                column.visible = false
                searchGrid.visible = true
                appflickable.contentY = 0
               // appflickable.contentHeight = searchGrid.height
            }
        }
    }

    function findItem(item) {
        for (i = 0; i < gridView.repeater.model.count; ++i) {
            if (gridView.repeater.model.get(i).name == item.name)
                return i
        }
    }

    Item {
        id: gridItem
        width: mainv.width
        height: mainv.height
//        Image {
//            rotation: isPortrait ? 0 : -90
//            source: "./wallpaper.png"
//            anchors.centerIn: parent
//        }

        Flickable {
            id: appflickable
            property alias column: column
            contentHeight: column.height
            contentWidth: isPortrait ? 400 : 700
            clip: true
            anchors {
                centerIn: parent.Center
                top: parent.top
                bottom: parent.bottom
                left: parent.left
                leftMargin: gridLeftMargin
                right: parent.right
                rightMargin: gridRightMargin
            }
            Behavior on contentY {
                NumberAnimation {
                }
            }

            AppSearchSection {
                id: searchGrid
                visible: false
            }

            Column {
                id: column
                anchors {
                    top: parent.top
                    left: parent.left
                    right: parent.right
                }

                Item {
                    height: 40
                    width: parent.width
                    visible: true
                }


                AppSection {
                    id: recentGrid
                    text: qsTr("Recently Used:")
                    onClearAppList: {

                    }

                    Connections {
                        target: mainView
                        onUpdateRecentApp: {
                            recentGrid.repeater.model.move(
                                        recentGrid.findRecentItem(item), 0, 1)
                            if (recentGrid.repeater.model.count > 14) {
                                recentGrid.repeater.model.remove(
                                            recentGrid.repeater.model.count - 1)
                            }
                        }
                    }

                    function findRecentItem(item) {
                        for (i = 0; i < recentGrid.repeater.model.count; ++i) {
                            if (recentGrid.repeater.model.get(
                                        i).name == item.name)
                                return i
                        }
                    }
                }

                AppSection {
                    id: desktopGrid
                    text: qsTr("Desktop:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: developmentGrid
                    text: qsTr("Development:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: educationGrid
                    text: qsTr("Education:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: gamesGrid
                    text: qsTr("Games:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: graphicsGrid
                    text: qsTr("Graphics:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: multimediaGrid
                    text: qsTr("Multimedia:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: networkGrid
                    text: qsTr("Network:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: locationGrid
                    text: qsTr("Location:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: officeGrid
                    text: qsTr("Office:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: systemGrid
                    text: qsTr("System:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: utilitiesGrid
                    text: qsTr("Utilities:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }

                AppSection {
                    id: otherGrid
                    text: qsTr("Other:")
                    onClearAppList: {
                        visible = false
                        repeater.model.clear()
                    }
                }
            }
        }
    }

    SectionMenu {
        id: sectionMenu
        z: 20
        onMenuVisibleChanged: {
            sectionMenuVisibleChanged(visible)
        }

        onPressed: {
            appflickable.contentY = column.children[i + 2].y
        }
    }

    Timer {
        running: true
        repeat: true
        interval: 60000 * 30
        onTriggered: {
            mainView.saveRecentApps()
        }
    }

    function currentFlickableItem() {

/*        if (isHildon) {
            var i
            for (i = 2; i < categoriesCount; ++i)
            {
                if (appflickable.contentY + 40 < column.children[i].y) {
                    break
                }
            }
            return i - 1
        } else*/ {
            var i
            for (i = 2; i < column.children.length; ++i)
            {
                if (appflickable.contentY + 40 < column.children[i].y) {
                    break
                }
            }
            return i - 3
        }
    }
}
